
/*
** Copyright (c) 2005 Herbert Poetzl
**
** V0.01	simplest waiter
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <stdint.h>


#include "vserver.h"
#include "switch.h"
#include "signal_cmd.h"
 

static	char	err_flag = 0;

static	char	opt_xid = 0;
static	char	opt_vers = 0;

static	char *	cmd_name = NULL;

static	int 	num_xid = 0;




#define OPTIONS "+hx:V"

int	main(int argc, char *argv[])
{
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r;


        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "-x <num>  wait for context <num>\n"
                    "-V        verify interface version\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
            case 'x':
                num_xid = atol(optarg);
                opt_xid = 1;
                break;
            case 'V':
                opt_vers = 1;
                break;
            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "]\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }

	if (opt_vers) {
	    r = vserver(VCMD_get_version, 0, NULL);
	    if (r<0)
	    	perror("vc_get_version");
    	    else 
	    	printf("version: %04x:%04x\n", 
		    (r>>16)&0xFFFF, r&0xFFFF);
	}

	if (opt_xid) {
	    r = vserver(VCMD_wait_exit, num_xid, NULL);
	    if (r<0)
	        perror("vc_wait_exit");
	} 
	
	exit((err_flag)?1:0);
}

